---
- name: Set molecule feature to false as default
  ansible.builtin.set_fact:
    ready_for_molecule: false

- name: Requirements for CentOS7/RHEL7
  ansible.builtin.include_tasks: redhat.yml
  when:
    - ansible_os_family | lower == "redhat"

- name: Requirements for Debian
  ansible.builtin.include_tasks: debian.yml
  when: (ansible_distribution == "Debian" and ansible_distribution_major_version == "10") or (ansible_distribution == "Ubuntu")

- name: Configure system for Molecule
  block:
    - name: Install molecule and dependencies
      ansible.builtin.pip:
        name: "{{ item }}"
        executable: pip3
      loop:
        - molecule
        - molecule-docker
        - molecule-podman
        - molecule-vagrant
        - docker
        - yamllint
        - ansible-lint
        - pytest
        - testinfra
        - ansible

    - name: Ensure docker service is running
      ansible.builtin.service:
        name: docker
        state: started
        enabled: true
      when: not (ansible_os_family | lower == "redhat" and ansible_distribution_major_version | int >= 8)

    - name: Detect if running in gitlab runner environment
      ansible.builtin.user:
        name: gitlab-runner
      check_mode: true
      register: gitlab_present
      ignore_errors: true
      changed_when: false

    - name: Add gitlab-runner user to docker group
      ansible.builtin.user:
        name: gitlab-runner
        groups:
          - docker
      when:
        - gitlab_present.state is defined
        - gitlab_present.state == "present"
        - molecule_install_detect_gitlabrunner
        - not (ansible_os_family | lower == "redhat" and ansible_distribution_major_version | int >= 8)

  when: ready_for_molecule
